1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
47 if [ $MSGLEVEL -le 3 ]; then
51 if [ $MSGLEVEL -le 4 ]; then
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
63 echo "${CDONE}DONE${CNORMAL}" >&2;
68 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
69 if [ -f .
/aptconfig.conf
]; then
70 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
71 elif [ -f ..
/aptconfig.conf
]; then
72 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
74 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
77 aptconfig
() { runapt apt
-config $
*; }
78 aptcache
() { runapt apt
-cache $
*; }
79 aptget
() { runapt apt
-get $
*; }
80 aptftparchive
() { runapt apt
-ftparchive $
*; }
81 aptkey
() { runapt apt
-key $
*; }
83 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
86 if [ -f .
/aptconfig.conf
]; then
87 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
88 elif [ -f ..
/aptconfig.conf
]; then
89 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
91 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
96 CURRENTTRAP
="$CURRENTTRAP $1"
97 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
101 TMPWORKINGDIRECTORY
=$(mktemp -d)
102 local TESTDIR
=$(readlink -f $(dirname $0))
103 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
104 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
105 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
106 local OLDWORKINGDIRECTORY
=$(pwd)
107 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
108 cd $TMPWORKINGDIRECTORY
109 mkdir rootdir aptarchive keys
111 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
112 mkdir -p var
/cache var
/lib var
/log
113 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
114 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
115 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
116 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
118 touch var/lib/dpkg/status
120 touch var/lib/dpkg/available
122 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
124 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
125 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
126 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
128 local SOURCESSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
129 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
130 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
132 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
133 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
134 echo "Dir
\"${TMPWORKINGDIRECTORY}/rootdir
\";" > aptconfig.conf
135 echo "Dir
::state
::status
\"${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
/status
\";" >> aptconfig.conf
136 echo "Debug
::NoLocking
\"true
\";" >> aptconfig.conf
137 echo "APT
::Get
::Show
-User-Simulation-Note \"false
\";" >> aptconfig.conf
138 echo "Dir
::Bin
::Methods
\"${BUILDDIRECTORY}/methods
\";" >> aptconfig.conf
139 echo "Dir
::Bin
::dpkg
\"fakeroot
\";" >> aptconfig.conf
140 echo "Dir
::Bin
::methods
\"${BUILDDIRECTORY}/methods
\";" >> aptconfig.conf
141 echo "DPKG
::options
:: \"dpkg
\";" >> aptconfig.conf
142 echo "DPKG
::options
:: \"--root=${TMPWORKINGDIRECTORY}/rootdir
\";" >> aptconfig.conf
143 echo "DPKG
::options
:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG
::options
:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG
::options
:: \"--log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
\";" >> aptconfig.conf
146 echo 'quiet::NoUpdate "true
";' >> aptconfig.conf
151 configarchitecture() {
152 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
153 echo "APT
::Architecture
\"$1\";" > $CONFFILE
155 while [ -n "$1" ]; do
156 echo "APT
::Architectures
:: \"$1\";" >> $CONFFILE
161 setupsimplenativepackage() {
165 local RELEASE="${4:-unstable}"
166 local DEPENDENCIES="$5"
167 local DESCRIPTION="$6"
168 local SECTION="${7:-others}"
170 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
173 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
175 local BUILDDIR=incoming/${NAME}-${VERSION}
176 mkdir -p ${BUILDDIR}/debian/source
178 echo "* most suckless software product ever
" > FEATURES
179 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
180 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
184 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
185 test -e debian/control || echo "Source
: $NAME
188 Maintainer
: Joe Sixpack
<joe@example.org
>
189 Build
-Depends: debhelper
(>= 7)
190 Standards
-Version: 3.9.1
192 Package
: $NAME" > debian/control
193 if [ "$ARCH" = 'all' ]; then
194 echo "Architecture
: all
" >> debian/control
196 echo "Architecture
: any
" >> debian/control
198 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
199 if [ -z "$DESCRIPTION" ]; then
200 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
201 If you
find such a package installed on your system
,
202 YOU did something horribly wrong
! They are autogenerated
203 und used only by testcases
for APT and surf no other propose…
" >> debian/control
205 echo "Description
: $DESCRIPTION" >> debian/control
207 test -e debian/compat || echo "7" > debian/compat
208 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
209 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
213 buildsimplenativepackage() {
217 local RELEASE="${4:-unstable}"
218 local DEPENDENCIES="$5"
219 local DESCRIPTION="$6"
220 local SECTION="${7:-others}"
222 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
225 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
227 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
229 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
230 mkdir -p $BUILDDIR/debian/source
231 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
233 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
235 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
236 echo "$NAME ($VERSION) $RELEASE; urgency
=low
240 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
244 Maintainer
: Joe Sixpack
<joe@example.org
>
245 Standards
-Version: 3.9.1
247 Package
: $NAME" > ${BUILDDIR}/debian/control
248 if [ "$ARCH" = 'all' ]; then
249 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
251 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
253 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
254 if [ -z "$DESCRIPTION" ]; then
255 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
256 If you
find such a package installed on your system
,
257 YOU did something horribly wrong
! They are autogenerated
258 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
260 echo "Description
: $DESCRIPTION" >> ${BUILDIR}/debian/control
262 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
263 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
265 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
266 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
267 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
268 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$ARCH)
269 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
271 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. > /dev/null
272 echo "pool
/${NAME}_
${VERSION}_
${ARCH}.deb
" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
274 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
284 msgninfo "Build package
$(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}…
"
286 if [ "$ARCH" = "all
" ]; then
287 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
289 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
290 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
291 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
294 echo "pool
/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
297 echo "pool
/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
303 if [ -d incoming ]; then
304 buildaptarchivefromincoming $*
306 buildaptarchivefromfiles $*
310 createaptftparchiveconfig() {
311 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb
$#\
1#' | tr '\n' ' ')"
312 if [ -z "$ARCHS" ]; then
313 # the pool is empty, so we will operate on faked packages - let us use the configured archs
314 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
317 ArchiveDir "' >> ftparchive.conf
318 echo -n $(readlink -f .) >> ftparchive.conf
320 CacheDir "' >> ftparchive.conf
321 echo -n $(readlink -f ..) >> ftparchive.conf
323 FileListDir "' >> ftparchive.conf
324 echo -n $(readlink -f pool/) >> ftparchive.conf
328 Packages::Compress ". gzip bzip2 lzma";
329 Sources::Compress ". gzip bzip2 lzma";
330 Contents::Compress ". gzip bzip2 lzma";
331 Translation::Compress ". gzip bzip2 lzma";
332 LongDescription "false";
336 SrcDirectory "pool/";
342 Label "apttestcases";
344 Description "repository with dummy packages";
345 Architectures "' >> ftparchive.conf
346 echo -n "$ARCHS" >> ftparchive.conf
350 };' >> ftparchive.conf
351 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
352 echo -n 'tree "dists/' >> ftparchive.conf
353 echo -n "$DIST" >> ftparchive.conf
355 Architectures "' >> ftparchive.conf
356 echo -n "$ARCHS" >> ftparchive.conf
358 FileList "' >> ftparchive.conf
359 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
361 SourceFileList "' >> ftparchive.conf
362 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
364 Sections "' >> ftparchive.conf
365 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
367 };' >> ftparchive.conf
371 buildaptftparchivedirectorystructure
() {
372 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
373 for DIST
in $DISTS; do
374 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
375 for SECTION
in $SECTIONS; do
376 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
377 for ARCH
in $ARCHS; do
378 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
380 mkdir -p dists
/${DIST}/${SECTION}/source
381 mkdir -p dists
/${DIST}/${SECTION}/i18n
391 local DEPENDENCIES
="$5"
393 if [ "$ARCHS" = "all" ]; then
394 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
396 for BUILDARCH
in $ARCHS; do
397 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
398 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
399 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
400 local FILE
="${PPATH}/Packages"
405 Maintainer: Joe Sixpack <joe@example.org>
408 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
409 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
410 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
411 If you find such a package installed on your system,
412 YOU did something horribly wrong! They are autogenerated
413 und used only by testcases for APT and surf no other propose…
418 buildaptarchivefromincoming
() {
419 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
421 [ -e pool
] || ln -s ..
/incoming pool
422 [ -e ftparchive.conf
] || createaptftparchiveconfig
423 [ -e dists
] || buildaptftparchivedirectorystructure
424 msgninfo
"\tGenerate Packages, Sources and Contents files… "
425 aptftparchive
-qq generate ftparchive.conf
431 buildaptarchivefromfiles
() {
432 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
433 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
434 msgninfo
"\t${line} file… "
435 cat ${line} | gzip > ${line}.gz
436 cat ${line} | bzip2 > ${line}.bz2
437 cat ${line} | lzma
> ${line}.lzma
443 generatereleasefiles
() {
444 msgninfo
"\tGenerate Release files… "
445 local DATE
="${1:-now}"
446 if [ -e aptarchive
/dists
]; then
447 for dir
in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
448 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Patterns
::='Translation-*' > $dir/Index
450 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
451 local CODENAME
="$(echo "$dir" | cut -d'/' -f 4)"
452 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Suite
="${CODENAME}" -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
453 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
455 NotAutomatic: yes' $dir/Release
459 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
461 if [ "$DATE" != "now" ]; then
462 for release
in $(find ./aptarchive -name 'Release'); do
463 touch -d "$1" $release
469 setupdistsaptarchive
() {
470 local APTARCHIVE
=$(readlink -f ./aptarchive)
471 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
472 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
473 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
474 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
475 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
476 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
477 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
482 setupflataptarchive
() {
483 local APTARCHIVE
=$(readlink -f ./aptarchive)
484 if [ -f ${APTARCHIVE}/Packages
]; then
485 msgninfo
"\tadd deb sources.list line… "
486 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
489 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
491 if [ -f ${APTARCHIVE}/Sources
]; then
492 msgninfo
"\tadd deb-src sources.list line… "
493 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
496 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
502 if [ -e aptarchive
/dists
]; then
508 msgninfo
"\tSync APT's cache with the archive… "
514 local SIGNER
="${1:-Joe Sixpack}"
515 msgninfo
"\tSign archive with $SIGNER key… "
517 for KEY
in $(find keys/ -name '*.sec'); do
518 SECKEYS
="$SECKEYS --secret-keyring $KEY"
521 for KEY
in $(find keys/ -name '*.pub'); do
522 PUBKEYS
="$PUBKEYS --keyring $KEY"
524 for RELEASE
in $(find aptarchive/ -name Release); do
525 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
526 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
531 changetowebserver
() {
532 if which weborf
> /dev
/null
; then
533 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
535 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
536 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
537 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
545 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
546 if [ -n "$DIFFTEXT" ]; then
558 msgtest
"Test for correctness of file" "$FILE"
560 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
562 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
567 local COMPAREFILE
=$(mktemp)
568 addtrap
"rm $COMPAREFILE;"
569 echo "$1" > $COMPAREFILE
571 msgtest
"Test for equality of" "$*"
572 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
576 local COMPAREFILE1
=$(mktemp)
577 local COMPAREFILE2
=$(mktemp)
578 local COMPAREAGAINST
=$(mktemp)
579 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
580 echo "$1" > $COMPAREFILE1
581 echo "$2" > $COMPAREFILE2
583 msgtest
"Test for equality OR of" "$*"
584 $
* 2>&1 1> $COMPAREAGAINST
585 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
586 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
587 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
588 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
593 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
596 while [ -n "$1" ]; do
598 N: Can't select versions from package '$1' as it purely virtual"
599 PACKAGE
="${PACKAGE} $1"
602 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
604 N: No packages found"
605 local COMPAREFILE
=$(mktemp)
606 addtrap
"rm $COMPAREFILE;"
607 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
608 eval `apt-config shell ARCH APT::Architecture`
609 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
610 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
614 msgtest
"Test for non-existent packages" "apt-cache show $*"
615 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
616 if [ -n "$SHOWPKG" ]; then
625 testdpkginstalled
() {
626 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
627 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
628 if [ "$PKGS" != 0 ]; then
630 dpkg
-l $
* | grep '^[a-z]'
637 testdpkgnoninstalled
() {
638 msgtest
"Test for correctly non-installed package(s) with" "dpkg -l $*"
639 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
640 if [ "$PKGS" != 0 ]; then
642 dpkg
-l $
* | grep '^[a-z]'